<?php 
/**
 * The Default template file.
 * 
 * @package	Alea
 * @author BlueOwlCreative
 */

get_header(); ?>


<!-- Posts Page -->
<?php 
	// Check Sidebar Layout
	$sidebar_layout = boc_posts_sidebar_layout();
?>
	<div class="container index_template layout_<?php echo esc_attr($sidebar_layout);?>">
		<div class="section">	
		
		<?php	
			// IF Sidebar Left
			if($sidebar_layout == 'left-sidebar'){
				get_sidebar();
			}

			if($sidebar_layout != 'full-width'){
				echo "<div class='post_content col span_3_of_4'>";
			}
		?>

		<?php 	// Loop Posts
				if( $wp_query->have_posts() ) { ?>
					<?php
						// Loop through blog posts
						foreach( $wp_query->posts as $post ){
							setup_postdata( $post );
							get_template_part('templates/loop-post');
						} 
					?>
					<?php
					boc_pagination($pages = '', $range = 3);
				}else{ ?>
			
					<p><?php esc_html_e('Sorry, no posts yet','alea'); ?></p>
				
		<?php	} ?>
		
		
		<?php 
			if($sidebar_layout != 'full-width'){
				echo "</div>";
			}

			// IF Sidebar Right
			if($sidebar_layout == 'right-sidebar'){
				get_sidebar();
			}
		?>
	</div>
</div>
<!-- Post :: END -->

<?php get_footer(); ?>	