        <?php
        // Check for search in header
        $show_search_option = boc_show_search_in_header();
        $show_search_separator_option = boc_show_search_separator();
        ?>
        <div class="header_content header_content_stripe">


            <?php if (is_active_sidebar('alea_header_icons_widget_area')) : ?>
                <!-- Header Icons Widget::START -->
                <div class="header_content_widgets">
                    <?php dynamic_sidebar('alea_header_icons_widget_area'); ?>
                </div>
                <!-- Header Icons Widget::END -->
            <?php endif; ?>


            <div class="header_content_icons">
                <?php if ($show_search_separator_option) { ?>
                    <span class="search_sep"></span>
                <?php } ?>
                <?php if ($show_search_option) { ?>
                    <a href="#" class="header_search_icon boc_i-search_icon"></a>
                <?php } ?>
    <!--        <a href="#" class="header_cart_icon boc_i-cart2"></a> -->
				
				 <?php
				// Cart in Header
				if (boc_cart_in_header()) {
					boc_render_cart_in_header();
				}
				?>				
            </div>
        </div>

       

        </div>
    </div>

    <div class="menu_stripe_holder <?php echo (get_full_width_stripe_menu() ? "full_width_container" : "container");?>">
        <div class="menu_stripe_style <?php echo get_stripe_menu_background();?>">
            <div class="<?php echo (get_full_width_stripe_menu() ? "container" : "");?>">
                <div id="menu">

					<?php if ( is_active_sidebar( 'alea_side_widget_area' ) ) : ?>
                    <div id="boc_menu_icon">
                        <div class="boc_menu_icon_ham button_closed line_1" id="boc_menu_icon_ham_1"></div>
                        <div class="boc_menu_icon_ham button_closed line_2" id="boc_menu_icon_ham_2"></div>
                        <div class="boc_menu_icon_ham button_closed line_3" id="boc_menu_icon_ham_3"></div>
                    </div>
					<?php endif; ?>

                    <?php
					do_action( 'boc_before_main_navigation' );
					
                    if (has_nav_menu('main_navigation')) {
                        wp_nav_menu(array(
                            'theme_location' => 'main_navigation',
                            'container' => '',
                            'items_wrap' => '<ul class="boc_main_menu '.get_submenu_background().' '.get_submenu_top_border().' ' .get_submenu_item_style().' '.get_submenu_item_hover_style().' '.get_submenu_item_hover_indent().'">%3$s</ul>',
                        ));
                    }
					
					do_action( 'boc_after_main_navigation' );
                    ?>

                </div>
            </div>
        </div>


<?php
$show_search_option = boc_show_search_in_header();
if ($show_search_option == 'on') {
    echo boc_search_form_in_header();
}
?>
