	<div class="container">	
		
		<div class="section portfolio_page">

	<?php while(have_posts()): the_post(); ?>
			
			<div class="portfolio_media col span_2_of_3 ">

			<?php // IF Post type is Standard (false) 	
			if(function_exists( 'get_post_format' ) && get_post_format( $post->ID ) != 'gallery' && get_post_format( $post->ID ) != 'video' && has_post_thumbnail()) { ?> 

				<?php if(has_post_thumbnail()): ?>

				<?php 	$attachment_image = wp_get_attachment_image_src(get_post_thumbnail_id(), 'full');
						$att_img_alt = get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true);
				?>
					<div class="pic">
						<a href="<?php echo esc_url($attachment_image[0]); ?>" class="mfp_popup">
							<img src="<?php echo esc_url($attachment_image[0]); ?>" alt="<?php echo esc_attr($att_img_alt);?>"/><div class="img_overlay"><span class="icon_zoom"></span></div>	  		
						</a>
					</div>

			<?php endif; ?>
			<?php } // IF Post type is Standard :: END ?>

			
			
			<?php // IF Post type is Gallery
			if (( function_exists( 'get_post_format' ) && get_post_format( $post->ID ) == 'gallery' )) {
				
				$images = get_post_meta($post->ID, "gallery", true);
										
				if($images){ 

					$images_arr = explode( ',', $images);
				
					$str = "<div id='img_slider_single_portfolio_template' class='img_slider mfp_gallery big_arrows opacity_0'>";
					foreach ( $images_arr as $img_id ){
		
						// Attachment VARS
						$att_img_link = wp_get_attachment_image_src( $img_id, 'full');
						$att_img_title = get_the_title($img_id);
						$att_img_alt = get_post_meta($img_id, '_wp_attachment_image_alt', true);

						$str .= '<div class="pic">
									<a href="'. esc_url($att_img_link[0]) .'" class="mfp_popup_gal" title="'. esc_attr($att_img_title) .'">
										<img src="'. esc_url($att_img_link[0]) .'" alt="'. esc_attr($att_img_alt) .'" class="boc_owl_lazy"/>
										<div class="img_overlay"><span class="hover_icon icon_zoom no_border"></span></div>
									</a>
								</div>';
					}
					$str .= '</div>';
				
					echo wp_kses_post($str);

					$js = '
					jQuery(document).ready(function($) {

						boc_preloadImages($("#img_slider_single_portfolio_template img"), function () {							
							$("#img_slider_single_portfolio_template").owlCarousel({
								items: 				1,
								nav: 				true,
								dots:				false,
								autoHeight: 		true,
								smartSpeed:			600,
								navText:			
								["<span class=\'icon boc_i-angle-left\'></span>","<span class=\'icon boc_i-angle-right\'></span>"],
								slideBy: 			1,
								navRewind: 			false,
								onInitialized: 		bocShowPortfolioCarousel
							});
						});
					});

					function bocShowPortfolioCarousel() {
						jQuery("#img_slider_single_portfolio_template").fadeTo(0,1);
						jQuery("#img_slider_single_portfolio_template .owl-item .boc_owl_lazy").css("opacity","1");
					}';

					wp_register_script('boc_portfolio_default_inline_script', false, array('alea-common'));
					wp_enqueue_script('boc_portfolio_default_inline_script');
					wp_add_inline_script('boc_portfolio_default_inline_script', $js );


				} // If Images :: END ?> 

			<?php } // IF Post type is Gallery :: END ?>		


			<?php	// IF Post type is Video 
					if (( function_exists( 'get_post_format' ) && get_post_format( $post->ID ) == 'video')  ) {				

						if($video_embed_code = get_post_meta($post->ID, 'video_embed_code', true)) {
							echo "<div class='video_max_scale'>";
							echo wp_kses($video_embed_code, boc_expand_allowed_tags());
							echo "</div>";
						}										
					} // IF Post type is Video :: END 
			?>

			</div>
			
			<div class="post_content col span_1_of_3 portfolio_description">
				<?php the_content(); ?>
			</div>
			
			<?php endwhile; // END LOOP ?>

	</div>
 </div>