<?php

/**
	Price Item
**/

// Register Shortcode
if( ! function_exists( 'shortcode_boc_price_item' ) ) {
	function shortcode_boc_price_item( $atts, $content = null ) {
		
		$atts = vc_map_get_attributes('boc_price_item', $atts );
		extract( $atts );
		
		$str = '<div class="boc_price_item '.esc_attr($css_classes).'">
					<div class="pi_text">'. $text .'</div>
					<div class="pi_dots"></div>
					<div class="pi_price">'. $price .'</div>
				</div>';
		return $str;
	}
	
	add_shortcode('boc_price_item', 'shortcode_boc_price_item');
}


// Map Shortcode in Visual Composer
vc_map( array(
   "name" 			=> esc_html__("Price Item", 'boc-shortcodes-and-widgets'),
   "description" 	=> esc_html__("Price Item", 'boc-shortcodes-and-widgets'),
   "base" 			=> "boc_price_item",
   "category" 		=> "Alea Shortcodes",
   "icon" 			=> "boc_price_item",
   "weight"			=> 27,
   "params" 		=> array(
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Text", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "text",
			"value" 		=> esc_html__("Price Item Text", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> "textfield",
			"heading"		=> esc_html__("Price", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "price",
			"value"			=> "$19.90",		
		),
		array(
			"type" 		=> "textfield",
			"heading" 	=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" => "css_classes",
			"value" 	=> "",
			"description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),	
	)
));